#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}




int main(int argc, char *argv[]){
	char *src_name;
	unsigned char *tbl;
	long tblsize;
	FILE *f;

	{
		int k;
		src_name = NULL;
		for(k = 1; argc > k; ++k){
			if(('-' == argv[k][0]) || ('/' == argv[k][0])){
				continue;
			}
			if(NULL == src_name){
				src_name = argv[k];
			}
		}
	}

	if(NULL == src_name){
		return 0;
	}


	f = fopen(src_name, "rb");
	if(NULL == f){
		return 1;
	}

	{
		unsigned char buf[4];
		fread(buf, 1, 4, f);
		tblsize = get_dword(buf);
		tbl = malloc(tblsize);
		fseek(f, 0, SEEK_SET);
		fread(tbl, 1, tblsize, f);
	}

	{
		long ofs;
		long t_ofs, t_size;
		unsigned char *t_name;
		unsigned char *buf;
		FILE *fo;

		ofs = 0;
		while(1){
			t_ofs = get_dword(tbl + ofs);
			if(0 == t_ofs){
				break;
			}
			t_name = (tbl + ofs + 4);
			ofs += (strlen(t_name) + 5);
			t_size = get_dword(tbl + ofs);
			if(0 == t_size){
				fseek(f, 0, SEEK_END);
				t_size = ftell(f);
			}
			t_size -= t_ofs;

			buf = malloc(t_size);
			if(NULL == buf){
				break;
			}
			fseek(f, t_ofs, SEEK_SET);
			fread(buf, 1, t_size, f);

			fo = fopen(t_name, "wb");
			fwrite(buf, 1, t_size, fo);
			fclose(fo);

			free(buf);
		}

	}

	free(tbl);
	fclose(f);

	return 0;
}
